#!/usr/bin/env python
import json
import socket
import sqlite3
import sys
import time
from datetime import datetime
from subprocess import Popen, PIPE

import nmap

conn = sqlite3.connect('/opt/tis-nagios/arpwatch.db')
c = conn.cursor()


def scan_host(host):
    nm = nmap.PortScanner()
    nm.scan(hosts=host, arguments='-n -p21,22,23,25,135,139,445,80,443,3389,8088,9100')
    for host_info in nm.all_hosts():
        if nm[host_info].state() == 'up':
            print nm[host_info]
            ports = [x for x in nm[host_info]['tcp'] if nm[host_info]['tcp'][x]['state'] == "open"]
            return ports


if not "hosts" in str(c.execute("select name from sqlite_master where type = 'table';").fetchall()):
    c.execute('''CREATE TABLE hosts  (date text, hostname text, mac text, ip text, interface text, ports text)''')

if len(sys.argv) > 1 and sys.argv[1] == "check":
    str = {"hostname": socket.getfqdn(), "interfaces": {}}
    for inf in c.execute('select interface from hosts group by interface').fetchall():
        res = c.execute('select date, hostname, mac, ip, ports  from hosts where interface = "%s" order by ip' % inf).fetchall()
        str['interfaces'][inf[0]] = sorted(res, key=lambda item: socket.inet_aton(item[3]))
    print json.dumps(str)
else:
    for line in sys.stdin.read().split('\n'):
        l = line.strip().split(':')
        if "hostname" in l:
            hostname = l[1].strip()
        if "ip address" in l:
            ip = l[1].strip()
        if "interface" in l:
            inf = l[1].strip()
        if "ethernet address" in l:
            mac = ":".join(l[1:]).strip()
        if "timestamp" in l:
            t = ":".join(l[1:]).split('+')[0].strip()
    date = time.mktime(datetime.strptime(t, "%A, %B %d, %Y %X").timetuple())
    ports = scan_host(ip)
    if "unknown" in hostname:
        try:
            hostname = socket.gethostbyaddr(ip)[0]
        except Exception:
            if "139" in str(ports) or "445" in str(ports):
                cmd = 'nmap -n --script smb-os-discovery.nse -p139,445 %s' % ip
                res = Popen(cmd.split(), stdout=PIPE).communicate()[0]
                try:
                    res =  res.split('|')
                    if 'NetBIOS' in str(res):
                        hostname = str([x.strip() for x in res if 'NetBIOS' in x][0].split(':')[1])
                    if 'Name' in str(res):
                        hostname = str([x.strip() for x in res if 'Name' in x][0].split(':')[1]).strip()
                except Exception:
                    pass

    c.execute("INSERT INTO hosts VALUES ('%s','%s','%s','%s','%s','%s')" % (date, hostname, mac, ip, inf, ports))
conn.commit()
conn.close()
