#!/usr/bin/python
# -*- coding: utf8 -*-
import netifaces
import sys
import os
sys.path.append(os.getcwd())
import dialog
from subprocess import Popen, PIPE


choices = []
#TODO add a check for multoprovider
if 'gateways' in dir(netifaces) and netifaces.gateways()['default'].has_key(netifaces.AF_INET):
    gw = netifaces.gateways()['default'][netifaces.AF_INET]
else:
    route = Popen("route -n".split(), stdout=PIPE)
    awk = Popen("""awk /^0.0.0.0/{print$NF}""".split(), stdin=route.stdout, stdout=PIPE).communicate()[0].strip()
    if awk:
        gw = ["nothing", awk]
    else:
        gw = ["nothing", "nothing"]
for name in netifaces.interfaces():
    if netifaces.ifaddresses(name).has_key(netifaces.AF_INET):
        addr = netifaces.ifaddresses(name)[netifaces.AF_INET][0]['addr']
        if ("192.168" in addr or "10." in addr or "172.16." in addr) \
                and not "tun" in name \
                and not "tap" in name \
                and not "ppp" in name \
                and not gw[1] in name \
                and not "lo" in name:
            choices.append((name, addr, 1)) 
        else:
            choices.append((name, addr, 0))
if not sys.stdout.isatty():
    if os.path.exists("/etc/shorewall/providers"):
        print "Auto conf will not work"
        sys.exit(1)
    interfaces = [x[0] for x in choices if x[2] == 1]
    code = 0

else:
    d = dialog.Dialog()

    code, interfaces = d.checklist(u"Quelles sont les interfaces à surveiller ?",
                                   choices=choices
                                   )
confile = "/etc/default/tis-arpwatch"
if code in [0, "ok"]:
    string ="#/bin/bash\n"
    for name in interfaces:
        string += "netdiscover -P -i %s -r %s\n" % (name,  netifaces.ifaddresses(name)[netifaces.AF_INET][0]['broadcast'])
    with open('/opt/tis-nagios/cron.sh', "w") as f:
        f.write(string)


    interfaces = " ".join(interfaces)
    conf = "#Interfaces watch by arpwatch\n" \
           "INTERFACES='%s'\n" % interfaces
    print "Add interfaces: %s to %s" % (interfaces, confile)
    with open(confile, 'w') as f:
        f.write(conf)
